# -*- coding: UTF-8 -*-

from nes_common.request_executor import RequestExecutor 
import ConfigParser
import sys
from nes_common import logger

class DB_RequestExecutor(RequestExecutor):
    
    def __init__(self, shop):
        log = logger.Logger().getLogger(shop.get('shopId', ''))
        config = ConfigParser.RawConfigParser()
        if not config.read(sys.path[0] + "/../../../config/nes_load.ini"):
            log.error("Configuration file 'nes_load.ini' not found.")
            sys.exit(1)
        host = config.get('mysql', 'host')
        port = config.getint('mysql', 'port')
        user = config.get('mysql', 'user')
        password = config.get('mysql', 'password')
        suffix = shop.get('shopId', '')
        if shop.get('shopId', '').endswith('All') and shop.get('shopId', '').startswith(shop.get('clusterId', '')):
            suffix = 'All'
        database = '%sdictionaries%s' % (shop.get('clusterId', ''), suffix)
        RequestExecutor.__init__(self, host, port, user, password, database, shop.get('shopId', ''))

