# -*- coding: utf-8 -*-

'''
Created on 30.08.2012

@author: chvv
'''

import simplesql as sql

tables = ['prices']

def insertPrice(price):
    yield sql.Insert(table='prices',values={
                    'barcode': price.get('barcode'),
                    'documentid': price.get('documentid', None),
                    'effectivedate': price.get('effectivedate', '0000-00-00 00:00:00'),
                    'doctype': price.get('doctype', None),
                    'price': price.get('price', None),
                    'minprice': price.get('minprice', None),
                    'pricetype': price.get('pricetype', None),
                    'effectivedateend': price.get('effectivedateend', None),
                    'minretailprice': price.get('minretailprice', None)
                    })

def deletePriceByBarcode(bcode, documentid= None, doctype= None):
    yield sql.Delete(table='prices',
                     whereFields=['barcode', 'documentid', 'doctype'],
                     whereValues=[bcode, documentid, doctype])
                     
def deletePrice(price):
    for i in deletePriceByBarcode(price.get('barcode', None), price.get('documentid', None), price.get('doctype', None)):
        yield i

def clearPrice():
    yield sql.DeleteAll(table='prices')

def deletePriceByDate(bcode, effectivedate=None, effectivedateend=None):
    yield sql.DeleteByDate(table='prices',
                     whereFields=['barcode', 'effectivedate', 'effectivedateend'],
                     whereValues=[bcode, effectivedate, effectivedateend])

def deleteOverduePrices(bcode):
    yield sql.DeleteOverduePrices(table='prices', whereFields=['barcode'], whereValues=[bcode])
