# -*- coding: UTF-8 -*-

from qpid.messaging import *
from qmf.console import Session
import os, sys, json

currntNesQueuesFilePath = '%s/currntNesQueues.txt' % sys.path[0]
resultFile = '%s/errQueues.txt' % sys.path[0]

currntQueues = {}

if os.path.exists(currntNesQueuesFilePath):
    f = open(currntNesQueuesFilePath, 'r')
    line = f.readline()
    if line:
        currntQueues = json.loads(line)
    f.close()

f = open(currntNesQueuesFilePath, 'w')

def getQueues(target, queuePrefix):
    filter_queues = []
    if os.name == 'posix':
        sess = None
        broker = None
        try:
            sess = Session()
            broker = sess.addBroker(target=target)
            queues = sess.getObjects(_class="queue", _package="org.apache.qpid.broker")
            for q in queues:
                if q.name.startswith(queuePrefix):
                    filter_queues.append(q)
        except Exception, e:
            print('Can not get queues with prefix %s. %s' % (queuePrefix, e))
        finally:
            if sess:
                sess.close()
    return filter_queues

queues = getQueues('localhost:5672', 'artix.loaddict.')
if os.path.exists(resultFile):
    os.remove(resultFile)
errQueues = []
for queue in queues:
    # если в предыдущую итерацию в очереди были сообщения, то проверяем была ли загрузка из такой очереди
    if currntQueues.get(queue.name, {}).get('currentMsg', 0) > 0 and currntQueues.get(queue.name, {}).get('outMsg', 0) == queue.msgTotalDequeues:
        errQueues.append(queue.name)
    currntQueues[queue.name] = {'currentMsg': queue.msgDepth, 'outMsg': queue.msgTotalDequeues}

if len(errQueues) > 0:
    errf = open(resultFile, 'a')
    errf.write(json.dumps(errQueues))
    errf.close()

f.write(json.dumps(currntQueues))

f.close()